diff --git a/web/pgadmin/tools/datagrid/tests/utils.py b/web/pgadmin/tools/datagrid/tests/utils.py
new file mode 100644
index 0000000..c3d4bb5
--- /dev/null
+++ b/web/pgadmin/tools/datagrid/tests/utils.py
@@ -0,0 +1,33 @@
+##########################################################################
+#
+# pgAdmin 4 - PostgreSQL Tools
+#
+# Copyright (C) 2013 - 2020, The pgAdmin Development Team
+# This software is released under the PostgreSQL Licence
+#
+##########################################################################
+import os
+import json
+
+file_name = os.path.basename(__file__)
+CURRENT_PATH = os.path.dirname(os.path.realpath(__file__))
+with open(CURRENT_PATH + "/datagrid_test_data.json") as data_file:
+    test_cases = json.load(data_file)
+
+
+def _init_query_tool(self, trans_id, server_group, server_id, db_id):
+    QUERY_TOOL_INIT_URL = '/datagrid/initialize/query_tool'
+
+    qt_init = self.tester.post(
+        '{0}/{1}/{2}/{3}/{4}'.format(
+            QUERY_TOOL_INIT_URL,
+            trans_id,
+            server_group,
+            server_id,
+            db_id
+        ),
+        follow_redirects=True
+    )
+    assert qt_init.status_code == 200
+    qt_init = json.loads(qt_init.data.decode('utf-8'))
+    return qt_init
diff --git a/web/pgadmin/tools/sqleditor/__init__.py b/web/pgadmin/tools/sqleditor/__init__.py
index 9d0903b..ca98ec4 100644
--- a/web/pgadmin/tools/sqleditor/__init__.py
+++ b/web/pgadmin/tools/sqleditor/__init__.py
@@ -10,17 +10,15 @@
 """A blueprint module implementing the sqleditor frame."""
 import os
 import pickle
-import sys
 import re
+from urllib.parse import unquote
 
 import simplejson as json
-from flask import Response, url_for, render_template, session, request, \
-    current_app
+from config import PG_DEFAULT_DRIVER, ON_DEMAND_RECORD_COUNT
+from flask import Response, url_for, render_template, session, current_app
+from flask import request, jsonify
 from flask_babelex import gettext
 from flask_security import login_required, current_user
-from urllib.parse import unquote
-
-from config import PG_DEFAULT_DRIVER, ON_DEMAND_RECORD_COUNT
 from pgadmin.misc.file_manager import Filemanager
 from pgadmin.tools.sqleditor.command import QueryToolCommand
 from pgadmin.tools.sqleditor.utils.constant_definition import ASYNC_OK, \
@@ -32,11 +30,11 @@ from pgadmin.tools.sqleditor.utils.update_session_grid_transaction import \
 from pgadmin.utils import PgAdminModule
 from pgadmin.utils import get_storage_directory
 from pgadmin.utils.ajax import make_json_response, bad_request, \
-    success_return, internal_server_error, make_response as ajax_response
+    success_return, internal_server_error
 from pgadmin.utils.driver import get_driver
-from pgadmin.utils.menu import MenuItem
-from pgadmin.utils.exception import ConnectionLost, SSHTunnelConnectionLost,\
+from pgadmin.utils.exception import ConnectionLost, SSHTunnelConnectionLost, \
     CryptKeyMissing
+from pgadmin.utils.menu import MenuItem
 from pgadmin.utils.sqlautocomplete.autocomplete import SQLAutoComplete
 from pgadmin.tools.sqleditor.utils.query_tool_preferences import \
     register_query_tool_preferences
@@ -44,10 +42,12 @@ from pgadmin.tools.sqleditor.utils.query_tool_fs_utils import \
     read_file_generator
 from pgadmin.tools.sqleditor.utils.filter_dialog import FilterDialog
 from pgadmin.tools.sqleditor.utils.query_history import QueryHistory
-from pgadmin.utils.constants import MIMETYPE_APP_JS, SERVER_CONNECTION_CLOSED,\
-    ERROR_MSG_TRANS_ID_NOT_FOUND
 from pgadmin.tools.sqleditor.utils.macros import get_macros,\
     get_user_macros, set_macros
+from pgadmin.utils.constants import MIMETYPE_APP_JS, \
+    SERVER_CONNECTION_CLOSED, ERROR_MSG_TRANS_ID_NOT_FOUND
+from pgadmin.model import Server
+from pgadmin.tools.schema_diff.node_registry import SchemaDiffRegistry
 
 MODULE_NAME = 'sqleditor'
 
@@ -113,7 +113,13 @@ class SqlEditorModule(PgAdminModule):
             'sqleditor.clear_query_history',
             'sqleditor.get_macro',
             'sqleditor.get_macros',
-            'sqleditor.set_macros'
+            'sqleditor.set_macros',
+            'sqleditor.get_new_connection_data',
+            'sqleditor.get_new_connection_database',
+            'sqleditor.get_new_connection_user',
+            'sqleditor.get_new_connection_role',
+            'sqleditor.connect_server',
+            'sqleditor.connect_server_with_user',
         ]
 
     def register_preferences(self):
@@ -229,7 +235,7 @@ def start_view_data(trans_id):
             )
 
     if status and conn is not None and \
-       trans_obj is not None and session_obj is not None:
+            trans_obj is not None and session_obj is not None:
         # set fetched row count to 0 as we are executing query again.
         trans_obj.update_fetched_row_cnt(0)
 
@@ -375,7 +381,7 @@ def poll(trans_id):
             if isinstance(trans_obj, QueryToolCommand):
                 trans_status = conn.transaction_status()
                 if trans_status == TX_STATUS_INERROR and \
-                   trans_obj.auto_rollback:
+                        trans_obj.auto_rollback:
                     conn.execute_void("ROLLBACK;")
 
             st, result = conn.async_fetchmany_2darray(ON_DEMAND_RECORD_COUNT)
@@ -685,13 +691,12 @@ def save(trans_id):
                                   status=404)
 
     if status and conn is not None and \
-       trans_obj is not None and session_obj is not None:
+            trans_obj is not None and session_obj is not None:
 
         # If there is no primary key found then return from the function.
         if ('primary_keys' not in session_obj or
-           len(session_obj['primary_keys']) <= 0 or
-           len(changed_data) <= 0) and \
-           'has_oids' not in session_obj:
+            len(session_obj['primary_keys']) <= 0 or
+                len(changed_data) <= 0) and 'has_oids' not in session_obj:
             return make_json_response(
                 data={
                     'status': False,
@@ -758,7 +763,7 @@ def append_filter_inclusive(trans_id):
                                   status=404)
 
     if status and conn is not None and \
-       trans_obj is not None and session_obj is not None:
+            trans_obj is not None and session_obj is not None:
 
         res = None
         filter_sql = ''
@@ -812,7 +817,7 @@ def append_filter_exclusive(trans_id):
                                   info='DATAGRID_TRANSACTION_REQUIRED',
                                   status=404)
     if status and conn is not None and \
-       trans_obj is not None and session_obj is not None:
+            trans_obj is not None and session_obj is not None:
 
         res = None
         filter_sql = ''
@@ -865,7 +870,7 @@ def remove_filter(trans_id):
                                   status=404)
 
     if status and conn is not None and \
-       trans_obj is not None and session_obj is not None:
+            trans_obj is not None and session_obj is not None:
 
         res = None
 
@@ -909,7 +914,7 @@ def set_limit(trans_id):
                                   status=404)
 
     if status and conn is not None and \
-       trans_obj is not None and session_obj is not None:
+            trans_obj is not None and session_obj is not None:
 
         res = None
 
@@ -1051,7 +1056,7 @@ def get_object_name(trans_id):
                                   status=404)
 
     if status and conn is not None and \
-       trans_obj is not None and session_obj is not None:
+            trans_obj is not None and session_obj is not None:
         res = trans_obj.object_name
     else:
         status = False
@@ -1087,7 +1092,7 @@ def set_auto_commit(trans_id):
                                   status=404)
 
     if status and conn is not None and \
-       trans_obj is not None and session_obj is not None:
+            trans_obj is not None and session_obj is not None:
 
         res = None
 
@@ -1132,7 +1137,7 @@ def set_auto_rollback(trans_id):
                                   status=404)
 
     if status and conn is not None and \
-       trans_obj is not None and session_obj is not None:
+            trans_obj is not None and session_obj is not None:
 
         res = None
 
@@ -1184,7 +1189,7 @@ def auto_complete(trans_id):
                                   status=404)
 
     if status and conn is not None and \
-       trans_obj is not None and session_obj is not None:
+            trans_obj is not None and session_obj is not None:
 
         # Create object of SQLAutoComplete class and pass connection object
         auto_complete_obj = SQLAutoComplete(
@@ -1470,6 +1475,284 @@ def get_filter_data(trans_id):
     return FilterDialog.get(status, error_msg, conn, trans_obj, session_ob)
 
 
+@blueprint.route(
+    '/new_connection_dialog/<int:sgid>/<int:sid>',
+    methods=["GET"], endpoint='get_new_connection_data'
+)
+@login_required
+def get_new_connection_data(sgid, sid=None):
+    """
+    This method is used to get required data for get new connection.
+    :extract_sql_from_network_parameters,
+    """
+    try:
+        # if sid and not did:
+        servers = Server.query.all()
+        server_list = [
+            {'name': server.serialize['name'], "id": server.serialize['id']}
+            for server in servers]
+
+        msg = "Success"
+        return make_json_response(
+            data={
+                'status': True,
+                'msg': msg,
+                'result': {
+                    'server_list': server_list
+                }
+            }
+        )
+
+    except Exception as e:
+        return make_json_response(
+            data={
+                'status': False,
+                'msg': 'Unable to fetch data.',
+                'result': {
+                    'server_list': []
+                }
+            }
+        )
+
+
+@blueprint.route(
+    '/new_connection_database/<int:sgid>/<int:sid>',
+    methods=["GET"], endpoint='get_new_connection_database'
+)
+@login_required
+def get_new_connection_database(sgid, sid=None):
+    """
+    This method is used to get required data for get new connection.
+    :extract_sql_from_network_parameters,
+    """
+    try:
+        database_list = []
+        from pgadmin.utils.driver import get_driver
+        manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(sid)
+        conn = manager.connection()
+        if conn.connected():
+            is_connected = True
+        else:
+            # connection = conn.connect()
+            is_connected = False
+        if is_connected:
+            if sid:
+                template_path = 'databases/sql/#{0}#'.format(manager.version)
+                last_system_oid = 0
+                server_node_res = manager
+
+                db_disp_res = None
+                params = None
+                if server_node_res and server_node_res.db_res:
+                    db_disp_res = ", ".join(
+                        ['%s'] * len(server_node_res.db_res.split(','))
+                    )
+                    params = tuple(server_node_res.db_res.split(','))
+                sql = render_template(
+                    "/".join([template_path, 'nodes.sql']),
+                    last_system_oid=last_system_oid,
+                    db_restrictions=db_disp_res
+                )
+                status, databases = conn.execute_dict(sql, params)
+                database_list = [
+                    {'label': database['name'], 'value': database['did']} for
+                    database in databases['rows']]
+            else:
+                status = False
+
+            msg = "Success"
+            return make_json_response(
+                data={
+                    'status': status,
+                    'msg': msg,
+                    'result': {
+                        'data': database_list,
+                    }
+                }
+            )
+        else:
+            return make_json_response(
+                data={
+                    'status': False,
+                    'msg': 'Server not connected, '
+                           'Please connect with server and try again.',
+                    'result': {
+                        'database_list': [],
+                    }
+                }
+            )
+    except Exception as e:
+        return make_json_response(
+            data={
+                'status': False,
+                'msg': 'Unable to fetch data.',
+                'result': {
+                    'database_list': [],
+                }
+            }
+        )
+
+
+@blueprint.route(
+    '/new_connection_user/<int:sgid>/<int:sid>',
+    methods=["GET"], endpoint='get_new_connection_user'
+)
+@login_required
+def get_new_connection_user(sgid, sid=None):
+    """
+    This method is used to get required data for get new connection.
+    :extract_sql_from_network_parameters,
+    """
+    try:
+        from pgadmin.utils.driver import get_driver
+        manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(sid)
+        conn = manager.connection()
+        user_list = []
+        if conn.connected():
+            is_connected = True
+        else:
+            is_connected = False
+        if is_connected:
+            if sid:
+                sql_path = 'roles/sql/#{0}#'.format(manager.version)
+                status, users = conn.execute_2darray(
+                    render_template(sql_path + 'nodes.sql')
+                )
+                user_list = [
+                    {'value': user['rolname'], 'label': user['rolname']} for
+                    user in users['rows'] if user['rolcanlogin']]
+            else:
+                status = False
+
+            msg = "Success"
+            return make_json_response(
+                data={
+                    'status': status,
+                    'msg': msg,
+                    'result': {
+                        'data': user_list,
+                    }
+                }
+            )
+        else:
+            return make_json_response(
+                data={
+                    'status': False,
+                    'msg': 'Server not connected, '
+                           'Please connect with server and try again.',
+                    'result': {
+                        'user_list': [],
+                    }
+                }
+            )
+    except Exception as e:
+        return make_json_response(
+            data={
+                'status': False,
+                'msg': 'Unable to fetch data.',
+                'result': {
+                    'user_list': [],
+                }
+            }
+        )
+
+
+@blueprint.route(
+    '/new_connection_role/<int:sgid>/<int:sid>',
+    methods=["GET"], endpoint='get_new_connection_role'
+)
+@login_required
+def get_new_connection_role(sgid, sid=None):
+    """
+    This method is used to get required data for get new connection.
+    :extract_sql_from_network_parameters,
+    """
+    try:
+        from pgadmin.utils.driver import get_driver
+        manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(sid)
+        conn = manager.connection()
+        role_list = []
+        if conn.connected():
+            is_connected = True
+        else:
+            is_connected = False
+        if is_connected:
+            if sid:
+                sql_path = 'roles/sql/#{0}#'.format(manager.version)
+                status, roles = conn.execute_2darray(
+                    render_template(sql_path + 'nodes.sql')
+                )
+                role_list = [
+                    {'value': role['rolname'], 'label': role['rolname']} for
+                    role in roles['rows']]
+            else:
+                status = False
+
+            msg = "Success"
+            return make_json_response(
+                data={
+                    'status': status,
+                    'msg': msg,
+                    'result': {
+                        'data': role_list,
+                    }
+                }
+            )
+        else:
+            return make_json_response(
+                data={
+                    'status': False,
+                    'msg': 'Server not connected, '
+                           'Please connect with server and try again.',
+                    'result': {
+                        'user_list': [],
+                    }
+                }
+            )
+    except Exception as e:
+        return make_json_response(
+            data={
+                'status': False,
+                'msg': 'Unable to fetch data.',
+                'result': {
+                    'user_list': [],
+                }
+            }
+        )
+
+
+@blueprint.route(
+    '/connect_server/<int:sid>/<usr>',
+    methods=["GET"],
+    endpoint="connect_server_with_user"
+)
+@blueprint.route(
+    '/connect_server/<int:sid>',
+    methods=["GET"],
+    endpoint="connect_server"
+)
+@login_required
+def connect_server(sid, usr=None):
+    # Check if server is already connected then no need to reconnect again.
+    server = Server.query.filter_by(id=sid).first()
+    driver = get_driver(PG_DEFAULT_DRIVER)
+    manager = driver.connection_manager(sid)
+    conn = manager.connection()
+    user = None
+    if usr and manager.user != usr:
+        user = usr
+    else:
+        if conn.connected():
+            return make_json_response(
+                success=1,
+                info=gettext("Server connected."),
+                data={}
+            )
+
+        view = SchemaDiffRegistry.get_node_view('server')
+        return view.connect(server.servergroup_id, sid, user=user)
+
+
 @blueprint.route(
     '/filter_dialog/<int:trans_id>',
     methods=["PUT"], endpoint='set_filter_data'
diff --git a/web/pgadmin/tools/sqleditor/static/js/sqleditor.js b/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
index ed3bd59..6abcf1d 100644
--- a/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
+++ b/web/pgadmin/tools/sqleditor/static/js/sqleditor.js
@@ -14,6 +14,7 @@ define('tools.querytool', [
   'jqueryui.position', 'underscore', 'pgadmin.alertifyjs',
   'sources/pgadmin', 'backbone', 'bundled_codemirror', 'sources/utils',
   'pgadmin.misc.explain',
+  'pgadmin.user_management.current_user',
   'sources/selection/grid_selector',
   'sources/selection/active_cell_capture',
   'sources/selection/clipboard',
@@ -26,6 +27,7 @@ define('tools.querytool', [
   'sources/sqleditor/execute_query',
   'sources/sqleditor/query_tool_http_error_handler',
   'sources/sqleditor/filter_dialog',
+  'sources/sqleditor/new_connection_dialog',
   'sources/sqleditor/geometry_viewer',
   'sources/sqleditor/history/history_collection.js',
   'sources/sqleditor/history/query_history',
@@ -53,8 +55,8 @@ define('tools.querytool', [
   'pgadmin.tools.user_management',
 ], function(
   gettext, url_for, $, jqueryui, jqueryui_position, _, alertify, pgAdmin, Backbone, codemirror, pgadminUtils,
-  pgExplain, GridSelector, ActiveCellCapture, clipboard, copyData, RangeSelectionHelper, handleQueryOutputKeyboardEvent,
-  XCellSelectionModel, setStagedRows, SqlEditorUtils, ExecuteQuery, httpErrorHandler, FilterHandler,
+  pgExplain, current_user, GridSelector, ActiveCellCapture, clipboard, copyData, RangeSelectionHelper, handleQueryOutputKeyboardEvent,
+  XCellSelectionModel, setStagedRows, SqlEditorUtils, ExecuteQuery, httpErrorHandler, FilterHandler, newConnectionHandler,
   GeometryViewer, historyColl, queryHist, querySources,
   keyboardShortcuts, queryToolActions, queryToolNotifications, Datagrid,
   modifyAnimation, calculateQueryRunTime, callRenderAfterPoll, queryToolPref, queryTxnStatus, csrfToken, panelTitleFunc,
@@ -98,6 +100,9 @@ define('tools.querytool', [
       this.layout = opts.layout;
       this.set_server_version(opts.server_ver);
       this.trigger('pgadmin-sqleditor:view:initialised');
+      this.connection_list = [
+        {'server_group': null,'server': null, 'database': null, 'user': null, 'role': null, 'title': '&lt;New Connection&gt;'},
+      ];
     },
 
     // Bind all the events
@@ -163,6 +168,35 @@ define('tools.querytool', [
       'click .btn-macro': 'on_execute_macro',
     },
 
+    render_connection: function(data_list) {
+      if(this.handler.is_query_tool) {
+        var dropdownElement = document.getElementById('connections-list');
+        dropdownElement.innerHTML = '';
+        data_list.forEach((option, index) => {
+          $('#connections-list').append('<li class="connection-list-item" data-index='+ index +'><a class="dropdown-item" href="#" tabindex="0">'+ option.title +'</a></li>');
+
+        });
+        var self = this;
+        $('.connection-list-item').click(function() {
+          self.get_connection_data(this);
+        });
+      } else {
+        $('.conn-info-dd').hide();
+        $('.editor-title').css({pointerEvents: 'none'});
+      }
+    },
+
+    get_connection_data: function(event){
+      var index = $(event).attr('data-index');
+      var connection_details = this.connection_list[index];
+      if(connection_details.server_group) {
+        this.on_change_connection(connection_details);
+      } else {
+        this.on_new_connection();
+      }
+
+    },
+
     reflectPreferences: function() {
       let self = this,
         browser = pgWindow.default.pgAdmin.Browser,
@@ -211,8 +245,15 @@ define('tools.querytool', [
       });
     },
 
-    set_editor_title: function(title) {
-      this.$el.find('.editor-title').text(title);
+    set_editor_title: function(title, is_connected) {
+      if(is_connected) {
+        this.$el.find('.editor-title').text(title);
+        this.render_connection(this.connection_list);
+      } else {
+        this.$el.find('.editor-title').text(title);
+        this.render_connection(this.connection_list);
+      }
+
     },
 
     // This function is used to render the template.
@@ -696,6 +737,8 @@ define('tools.querytool', [
       pgBrowser.register_to_activity_listener(document, ()=>{
         alertify.alert(gettext('Timeout'), gettext('Your session has timed out due to inactivity. Please close the window and login again.'));
       });
+
+      self.render_connection(self.connection_list);
     },
 
     /* Regarding SlickGrid usage in render_grid function.
@@ -1607,6 +1650,17 @@ define('tools.querytool', [
       );
     },
 
+    on_new_connection: function() {
+      var self = this;
+
+      // Trigger the show_filter signal to the SqlEditorController class
+      self.handler.trigger(
+        'pgadmin-sqleditor:button:show_new_connection',
+        self,
+        self.handler
+      );
+    },
+
     // Callback function for include filter button click.
     on_include_filter: function(ev) {
       var self = this;
@@ -2070,6 +2124,83 @@ define('tools.querytool', [
       queryToolActions.executeMacro(this.handler, macroId);
     },
 
+    on_change_connection: function(connection_details, ref) {
+      let title = this.$el.find('.editor-title').html();
+      if(connection_details['title'] != title) {
+        var self = this;
+        $.ajax({
+          async: false,
+          url: url_for('datagrid.update_query_tool_connection', {
+            'trans_id': self.transId,
+            'sgid': connection_details['server_group'],
+            'sid': connection_details['server'],
+            'did': connection_details['database'],
+          }),
+          method: 'POST',
+          contentType: 'application/json',
+          data: JSON.stringify(connection_details),
+        })
+          .done(function(res) {
+            if(res.success) {
+              self.transId = res.data.tran_id;
+              self.handler.transId = res.data.tran_id;
+              self.handler.url_params = {
+                'did': connection_details['database'],
+                'is_query_tool': self.handler.url_params.is_query_tool,
+                'server_type': self.handler.url_params.server_type,
+                'sgid': connection_details['server_group'],
+                'sid': connection_details['server'],
+                'title': connection_details['title'],
+              };
+              self.set_editor_title(self.handler.url_params.title);
+              self.handler.setTitle(self.handler.url_params.title);
+              alertify.success('connected successfully');
+              if(ref){
+                let connection_data = {
+                  'server_group': self.handler.url_params.sgid,
+                  'server': connection_details['server'],
+                  'database': connection_details['database'],
+                  'user': connection_details['user'],
+                  'title': connection_details['title'],
+                  'role': connection_details['role'],
+                  'password': connection_details['password'],
+                  'is_allow_new_connection': true,
+                };
+                self.connection_list.unshift(connection_data);
+                self.render_connection(self.connection_list);
+                ref.close();
+              }
+            }
+            return true;
+          })
+          .fail(function(xhr) {
+            if(xhr.status == 428) {
+              alertify.connectServer('Connect to server', xhr.responseJSON.result, connection_details['server'], false);
+            } else {
+              alertify.error(xhr.responseJSON['errormsg']);
+            }
+            /*let url = url_for('sqleditor.connect_server_with_user', {
+              'sid': newConnCollectionModel['server'],
+              'usr': newConnCollectionModel['user']
+            });
+            $.ajax({
+              async: false,
+              url: url,
+              headers: {
+                'Cache-Control' : 'no-cache',
+              },
+            }).done(function () {
+              Backform.Select2Control.prototype.onChange.apply(self, arguments);
+              response.server_list.forEach(function(obj){
+                if(obj.id==self.model.changed.server) {
+                  response.server_name = obj.name;
+                }
+              });
+            }).fail(function(xhr){});*/
+
+          });
+      }
+    },
   });
 
 
@@ -2392,7 +2523,18 @@ define('tools.querytool', [
           });
 
           $('#btn-conn-status i').removeClass('obtaining-conn');
-          self.gridView.set_editor_title(_.unescape(url_params.title));
+          self.gridView.set_editor_title(_.unescape(url_params.title), true);
+          let connection_data = {
+            'server_group': self.gridView.handler.url_params.sgid,
+            'server': self.gridView.handler.url_params.sid,
+            'database': self.gridView.handler.url_params.did,
+            'user': null,
+            'role': null,
+            'title': _.unescape(url_params.title),
+            'is_allow_new_connection': false,
+          };
+          self.gridView.connection_list.unshift(connection_data);
+          self.gridView.render_connection(self.gridView.connection_list);
         };
 
         pgBrowser.Events.on('pgadmin:query_tool:connected:' + transId, afterConn);
@@ -2487,6 +2629,7 @@ define('tools.querytool', [
         self.on('pgadmin-sqleditor:button:save_file', self._save_file, self);
         self.on('pgadmin-sqleditor:button:deleterow', self._delete, self);
         self.on('pgadmin-sqleditor:button:show_filter', self._show_filter, self);
+        self.on('pgadmin-sqleditor:button:show_new_connection', self._show_new_connection, self);
         self.on('pgadmin-sqleditor:button:include_filter', self._include_filter, self);
         self.on('pgadmin-sqleditor:button:exclude_filter', self._exclude_filter, self);
         self.on('pgadmin-sqleditor:button:remove_filter', self._remove_filter, self);
@@ -3696,7 +3839,6 @@ define('tools.querytool', [
           }
         };
       },
-
       // This function will show the filter in the text area.
       _show_filter: function() {
         let self = this,
@@ -3711,7 +3853,19 @@ define('tools.querytool', [
         }
         FilterHandler.dialog(self, reconnect);
       },
+      // This function will show the new connection.
+      _show_new_connection: function() {
+        let self = this,
+          reconnect = false;
 
+        /* When server is disconnected and connected, connection is lost,
+         * To reconnect pass true
+         */
+        if (arguments.length > 0 && arguments[arguments.length - 1] == 'connect') {
+          reconnect = true;
+        }
+        newConnectionHandler.dialog(self, reconnect);
+      },
       // This function will include the filter by selection.
       _include_filter: function() {
         var self = this,
